﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WdtClient;
using WdtClient.api;
using WdtClient.api.sales;
using WdtClient.api.system;
using WdtClient.api.script;
using WdtClient.impl;

namespace Demo
{
    class Program
    {
        static void TestCore(IClient client)
        {
            CoreAPI coreApi = ApiFactory<CoreAPI>.Get(client);
            long timestamp = coreApi.Now();
            Console.WriteLine(timestamp);

        }

        // 自有平台的订单推送
        static void PushTrade(IClient client)
        {
            var rawTrade = new RawTrade
            {
                Tid = "TIDXXX002",
                TradeTime = "2018-03-15 12:20:30",
                PayTime = "2018-03-15 12:20:31",
                BuyerNick = "WGQ001",
                ReceiverName = "aa",
                ReceiverArea = "安徽省安庆市桐城县",
                ReceiverAddress = "AABBCC",
                ReceiverMobile = "1388808080",
                Remark = "注意呀",
                Receivable = 1.5m,
                PostAmount = 0.5m
            };

            var rawOrder = new RawTradeOrder
            {
                Tid = "TIDXXX002",
                Oid = "OXXx002xx",
                GoodsId = "000001",
                SpecId = "OIDXXXY2",
                GoodsNo = "GOODS111",
                SpecNo = "SpecNo",
                GoodsName = "测试商品XXX",
                SpecName = "测试规格X",
                Num = 1,
                Price = 1.5m,
                TotalAmount = 1.5m
            };

            RawTradeAPI rawTradeApi = ApiFactory<RawTradeAPI>.Get(client);

            var result = rawTradeApi.Push(153, new List<RawTrade> { rawTrade }, new List<RawTradeOrder> { rawOrder });
            Console.WriteLine(result.NewCount);
        }

        static void TestScript(IClient client)
        {
            ScriptTest scriptTest = ExApiFactory<ScriptTest>.Get(client);
            int result = scriptTest.Add(121, 2);
            Console.WriteLine(result);
        }

        static void TestStock(IClient client)
        {
            StockAPI stockAPI = ApiFactory<StockAPI>.Get(client);

            var pars = new StockQueryParams
            {
                WarehouseNo = "yichang",
                //SpecNo = "bh001",
                StartTime = "2018-11-12 00:00:00",
                EndTime = "2018-12-12 00:00:00",
            };

            StockQueryResult result = stockAPI.Search(pars, new Pager(10, 0, true));
            Console.WriteLine(result);
        }

        static void TestGoods(IClient client)
        {
            GoodsAPI goodsAPI = ApiFactory<GoodsAPI>.Get(client);

            var goodsInfo = new GoodsInfo
            {
                GoodsNo = "push_goods_no",
                GoodsName = "测试一下推送",
                ShortName = "haha"
            };

            var specList= new List<SpecInfo>
            {
                new SpecInfo
                {
                    SpecNo = "push_spec_no",
                    SpecCode = "push_spec_code",
                    SpecName = "推送个规格"
                }
            };

            int goodsId = goodsAPI.Push(goodsInfo, specList);
            Console.WriteLine(goodsId);
        }

        static void Main(string[] args)
        {
            IClient client = new DefaultClient("wdterp30", "http://127.0.0.1:30000/", "test", "2b03710925bb19290ea5ff11830f8c3b:0fae66ba875ce35df0bf2ff8916d0235");

            //TestCore(client);
            //PushTrade(client);
            //TestScript(client);

            TestGoods(client);
        }
    }
}
