﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WdtClient.api.sales
{
    public class GoodsInfo
    {
        // 货品类型
        public const byte TYPE_OTHER = 0; //其他
        public const byte TYPE_SALES = 1; //销售货品
        public const byte TYPE_PACKAGE = 3; //包装物
        public const byte TYPE_VIRTUAL = 5; //虚拟产品
        public const byte TYPE_REPAIR = 7; //保修配件
        
        /// <summary>
        /// 货品编号
        /// </summary>
        public string GoodsNo;

        /// <summary>
        /// 货品名称
        /// </summary>
        public string GoodsName;

        /// <summary>
        /// 简称
        /// </summary>
        public string ShortName;

        /// <summary>
        /// 别名
        /// </summary>
        public string Alias;

        /// <summary>
        /// 分类名称
        /// </summary>
        public string ClassName;

        /// <summary>
        /// 品牌名
        /// </summary>
        public string BrandName;

        /// <summary>
        /// 基本单位
        /// </summary>
        public string UnitName;

        /// <summary>
        /// 辅助单位
        /// </summary>
        public string AuxUnitName;

        /// <summary>
        /// 标旗
        /// </summary>
        public string FlagName;

        /// <summary>
        /// 货品类型
        /// </summary>
        public int GoodsType;

        /// <summary>
        /// 产地
        /// </summary>
        public string Origin;

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark;

        /// <summary>
        /// 自定义属性
        /// </summary>
        public string Prop1;
        public string Prop2;
        public string Prop3;
        public string Prop4;
        public string Prop5;
        public string Prop6;
    }

    public class SpecInfo
    {
        //大件类别
        public const sbyte LARGE_TYPE_NON_ALONE = -1;	//非单发件
        public const sbyte LARGE_TYPE_NONE = 0;		//非大件
        public const sbyte LARGE_TYPE_NORMAL = 1;		//普通大件
        public const sbyte LARGE_TYPE_EXCLUSIVE = 2;	//独立大件
        public const sbyte LARGE_TYPE_BOXCAPACITY = 3;	//按箱规拆分

        //sn类型
        public const byte SN_TYPE_NONE = 0;	//不管理sn
        public const byte SN_TYPE_STRONG = 1;//强SN,出入库都要扫sn
        public const byte SN_TYPE_WEAK = 2;	//弱sn,出库扫sn,入库不扫

        /// <summary>
        /// 商家编码
        /// </summary>
        public string SpecNo;

        /// <summary>
        /// 规格码
        /// </summary>
        public string SpecCode;

        /// <summary>
        /// 规格名
        /// </summary>
        public string SpecName;

        /// <summary>
        /// 主条码
        /// </summary>
        public string Barcode;

        /// <summary>
        /// 零售价
        /// </summary>
        public decimal RetailPrice;

        /// <summary>
        /// 批发价
        /// </summary>
        public decimal WholesalePrice;

        /// <summary>
        /// 会员价
        /// </summary>
        public decimal MemberPrice;

        /// <summary>
        /// 市场价
        /// </summary>
        public decimal MarketPrice;

        /// <summary>
        /// 最低价
        /// </summary>
        public decimal LowestPrice;

        /// <summary>
        /// 有效期天数
        /// </summary>
        public int ValidityDays;

        public int SalesDays;
        public int ReceiveDays;

        /// <summary>
        /// 长度(cm)
        /// </summary>
        public decimal Length;

        /// <summary>
        /// 宽度(cm)
        /// </summary>
        public decimal Width;

        /// <summary>
        /// 高度(cm)
        /// </summary>
        public decimal Height;

        /// <summary>
        /// 重量kg
        /// </summary>
        public decimal Weight;

        /// <summary>
        /// 税率
        /// </summary>
        public decimal TaxRate;
        
        /// <summary>
        /// SN方式
        /// </summary>
        public byte SnType;

        /// <summary>
        /// 货品标签, 字符串以逗号拼接方式
        /// </summary>
        public string GoodsLabel;

        /// <summary>
        /// 大件类型
        /// </summary>
        public int LargeType;

        /// <summary>
        /// 基本单位
        /// </summary>
        public string UnitName;

        /// <summary>
        /// 辅助单位
        /// </summary>
        public string AuxUnitName;

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark;

        /// <summary>
        /// 自定义属性
        /// </summary>
        public string Prop1;
        public string Prop2;
        public string Prop3;
        public string Prop4;
        public string Prop5;
        public string Prop6;
    }

    public interface GoodsAPI
    {
        /// <summary>
        /// 推送货品到ERP
        /// </summary>
        /// <param name="goodsInfo">货位信息</param>
        /// <param name="specInfoList">规格列表</param>
        /// <returns></returns>
        [Api("goods.Goods.push")]
        int Push(GoodsInfo goodsInfo, List<SpecInfo> specInfoList);
    }
}
