﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WdtClient.api.system
{
    /// <summary>
    /// 查询条件
    /// </summary>
    public class StockQueryParams
    {
        /// <summary>
        /// 仓库编号, 必要
        /// </summary>
        public string WarehouseNo;
        
        /// <summary>
        /// 商家编码, 可选
        /// </summary>
        public string SpecNo;

        /// <summary>
        /// 最后出入库时间
        /// </summary>
        public string StartTime;

        /// <summary>
        /// 最后出入库时间
        /// </summary>
        public string EndTime;
        
        /// <summary>
        /// 是否返回成本
        /// </summary>
        public bool ReturnCost; 
    }

    /// <summary>
    /// 货品库存信息
    /// </summary>
    public class GoodsSpecStock
    {
        /// <summary>
        /// SKU内部ID
        /// </summary>
        public int SpecId;

        /// <summary>
        /// 是否残次品
        /// </summary>
        public bool Defect;

        /// <summary>
        /// 商家编码
        /// </summary>
        public string SpecNo;
        
        /// <summary>
        /// 主条码
        /// </summary>
        public string Barcode;

        /// <summary>
        /// 库存量
        /// </summary>
        public decimal StockNum;

        /// <summary>
        /// 最后出入库时间
        /// </summary>
        public string Modified;
    }

    /// <summary>
    /// 查找返回结果
    /// </summary>
    public class StockQueryResult : List<GoodsSpecStock>
    {
        public int Total; // 总记数数
    }

    public interface StockAPI
    {
        /// <summary>
        /// 库存查询
        /// </summary>
        /// <returns></returns>
        [Api("wms.StockSpec.search", true)]
        StockQueryResult Search(StockQueryParams pars, Pager pager);

    }
}
